searchNodes=[{"doc":"Formatter for the Erlang logger library which outputs JSON. https://www.erlang.org/doc/apps/kernel/logger_chapter.html#formatters","ref":"logger_formatter_json.html","title":"logger_formatter_json","type":"module"},{"doc":"","ref":"logger_formatter_json.html#check_config/1","title":"logger_formatter_json.check_config/1","type":"function"},{"doc":"","ref":"logger_formatter_json.html#format/2","title":"logger_formatter_json.format/2","type":"function"},{"doc":"","ref":"logger_formatter_json.html#t:config/0","title":"logger_formatter_json.config/0","type":"type"},{"doc":"","ref":"logger_formatter_json.html#t:metakey/0","title":"logger_formatter_json.metakey/0","type":"type"},{"doc":"","ref":"logger_formatter_json.html#t:template/0","title":"logger_formatter_json.template/0","type":"type"},{"doc":"logger_formatter_json This is a formatter for the Erlang logger application that outputs JSON. It implements the formatter API for the high-performance logger application introduced in OTP 21. It formats log messages and logger metadata as JSON, supporting naming conventions from services such as Datadog and Google Cloud It is written in Erlang with no dependencies except for the Erlang JSON library thoas . It can be used by pure Erlang projects as well as other BEAM languages such as Elixir.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Erlang: Add logger_formatter_json to the list of dependencies in rebar.config : { deps , [ logger_formatter_json ] } . Elixir: Add logger_formatter_json to the list of dependencies in mix.exs : def deps do [ { :logger_formatter_json , &quot;~&gt; 0.7&quot; } , ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"JSON output is mostly useful for production, as it makes it easier for tools to parse log output, but it can be excessively verbose for development. If you use a lot of metatadata, a library like flatlog produces output that is easier for humans to read. In order to make all log output in consistent JSON format, including system messages, configure the formatter as the default for all applications running on the VM. Erlang: Configure the kernel default handler in the sys.config file for the release: [ { kernel , [ { logger , [ { handler , default , logger_std_h , \#{ formatter =&gt; { logger_formatter_json , \#{ } } } } ] } , { logger_level , info } ] } ] . Elixir: The Elixir logging system starts after the kernel logger, so setting it as part of the release runtime is the most reliable way of getting everything to use JSON output. Configure the kernel default logger in config/config.exs or config/runtime.exs : if System . get_env ( &quot;RELEASE_MODE&quot; ) do config :kernel , :logger , [ { :handler , :default , :logger_std_h , %{ formatter : { :logger_formatter_json , %{ } } } } ] end The check for the RELEASE_MODE environment variable makes the code only run when building a release. Set options for the Elixir logging system in config/prod.exs : config :logger , level : :info , utc_log : true config :logger , :console , metadata : [ :time , :level , :file , :line , :mfa , :pid , :request_id , :trace_id , :span_id ] It is also possible to configure the logger just for your application and environment. Add a call to :logger.add_handlers in your application startup file, e.g. lib/foo/application.ex : def start ( _type , _args ) do :logger . add_handlers ( :foo ) Then add the handler to config/prod.exs : config :foo , :logger , [ { :handler , :default , :logger_std_h , %{ formatter : { :logger_formatter_json , %{ } } } } ]","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"The formatter accepts a map of options, e.g.: config :foo , :logger , [ { :handler , :default , :logger_std_h , %{ formatter : { :logger_formatter_json , %{ names : %{ time : &quot;date&quot; , level : &quot;status&quot; , msg : &quot;message&quot; } } } } } ] names is a map of keys in the metadata map to string keys in the JSON output. The module has predefined sets of keys for datadog and gcp . config :foo , :logger , [ { :handler , :default , :logger_std_h , %{ formatter : { :logger_formatter_json , %{ names : :datadog } } } } ] You can also specify a list to add your own tags to the predefined ones, e.g. of options, e.g. names: [datadog, %{foo: &quot;bar&quot;}] . types is a map which identifies keys with a special format that the module understands ( level , system_time , mfa ). template is a list of metadata to format. This lets you put keys in specific order to make them easier to read in the output. For example: template : [ :msg , :time , :level , :file , :line , :mfa , :pid , :trace_id , :span_id ] List elements are metadata key names, with a few special keys: msg represents the text message, if any. If you call logger:info(&quot;the message&quot;) , then it would be rendered in the JSON as {&quot;msg&quot;: &quot;the message&quot;, ...} . You can map the key msg to e.g. message via the names config option. all represents all the metadata keys. rest represents all the metadata keys which have not been handled explicitly. You can specify a group of keys as a tuple like {group, &lt;name&gt;, [&lt;list of metadata keys&gt;]} , and they will be collected into a map in the output. For example: { group , source_location , [ file , line , mfa ] } , { group , tags , [ rest ] } This would result in a log message like: { ... &quot;source_location&quot;: {&quot;file:&quot; &quot;mymodule.ex&quot;, &quot;line&quot;: 17, &quot;mfa&quot;: &quot;mymodule:thefunction/1&quot;}, &quot;tags&quot;: {&quot;foo&quot;: &quot;bar&quot;, &quot;biz&quot;: &quot;baz&quot;} } The default template is [msg, all] . You can also use a tuple to specify a standard set of keys to be used: {keys, basic} : [time, level, msg] {keys, trace} : [trace_id, span_id] {keys, gcp} : [ msg , time , level , trace_id , span_id , { group , source_location , [ file , line , mfa ] } , { group , tags , [ rest ] } ] You can specify multiple templates, so you can add your own metadata keys to one of the standard templates, e.g. [{keys, basic}, request_id, trace_id, span_id] .","ref":"readme.html#configuration","title":"Overview - Configuration","type":"extras"},{"doc":"Much thanks to Fred Hebert, as always. Erlang/OTP 21's new logger flatlog Canonical log lines","ref":"readme.html#links","title":"Overview - Links","type":"extras"},{"doc":"Build: rebar3 compile Test: rebar3 ct There are also tests written in Elixir. Change to the mix_tests directory and run: MIX_ENV=test mix deps.get mix test Format code: rebar3 steamroll Generate docs: rebar3 ex_docs Publish: rebar3 hex user auth rebar3 hex build rebar3 hex publish This project uses the Contributor Covenant version 2.1. Check CODE_OF_CONDUCT.md for more information.","ref":"readme.html#contributing","title":"Overview - Contributing","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Added Initial version","ref":"changelog.html#0-7-0-2023-03-20","title":"Changelog - [0.7.0] - 2023-03-20","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS Copyright 2022, Jake Morrison &lt;jake@cogini.com&gt;. Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License (Apache 2.0)","type":"extras"},{"doc":"","ref":"code_of_conduct.html","title":"Code of Conduct","type":"extras"},{"doc":"We as members, contributors, and leaders pledge to make participation in our community a harassment-free experience for everyone, regardless of age, body size, visible or invisible disability, ethnicity, sex characteristics, gender identity and expression, level of experience, education, socio-economic status, nationality, personal appearance, race, caste, color, religion, or sexual identity and orientation. We pledge to act and interact in ways that contribute to an open, welcoming, diverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge","title":"Code of Conduct - Our Pledge","type":"extras"},{"doc":"Examples of behavior that contributes to a positive environment for our community include: Demonstrating empathy and kindness toward other people Being respectful of differing opinions, viewpoints, and experiences Giving and gracefully accepting constructive feedback Accepting responsibility and apologizing to those affected by our mistakes, and learning from the experience Focusing on what is best not just for us as individuals, but for the overall community Examples of unacceptable behavior include: The use of sexualized language or imagery, and sexual attention or advances of any kind Trolling, insulting or derogatory comments, and personal or political attacks Public or private harassment Publishing others' private information, such as a physical or email address, without their explicit permission Other conduct which could reasonably be considered inappropriate in a professional setting","ref":"code_of_conduct.html#our-standards","title":"Code of Conduct - Our Standards","type":"extras"},{"doc":"Community leaders are responsible for clarifying and enforcing our standards of acceptable behavior and will take appropriate and fair corrective action in response to any behavior that they deem inappropriate, threatening, offensive, or harmful. Community leaders have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct, and will communicate reasons for moderation decisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities","title":"Code of Conduct - Enforcement Responsibilities","type":"extras"},{"doc":"This Code of Conduct applies within all community spaces, and also applies when an individual is officially representing the community in public spaces. Examples of representing our community include using an official e-mail address, posting via an official social media account, or acting as an appointed representative at an online or offline event.","ref":"code_of_conduct.html#scope","title":"Code of Conduct - Scope","type":"extras"},{"doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be reported to the community leaders responsible for enforcement at engineering@therealreal.com. All complaints will be reviewed and investigated promptly and fairly. All community leaders are obligated to respect the privacy and security of the reporter of any incident.","ref":"code_of_conduct.html#enforcement","title":"Code of Conduct - Enforcement","type":"extras"},{"doc":"Community leaders will follow these Community Impact Guidelines in determining the consequences for any action they deem in violation of this Code of Conduct: 1. Correction Community Impact : Use of inappropriate language or other behavior deemed unprofessional or unwelcome in the community. Consequence : A private, written warning from community leaders, providing clarity around the nature of the violation and an explanation of why the behavior was inappropriate. A public apology may be requested. 2. Warning Community Impact : A violation through a single incident or series of actions. Consequence : A warning with consequences for continued behavior. No interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, for a specified period of time. This includes avoiding interactions in community spaces as well as external channels like social media. Violating these terms may lead to a temporary or permanent ban. 3. Temporary Ban Community Impact : A serious violation of community standards, including sustained inappropriate behavior. Consequence : A temporary ban from any sort of interaction or public communication with the community for a specified period of time. No public or private interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, is allowed during this period. Violating these terms may lead to a permanent ban. 4. Permanent Ban Community Impact : Demonstrating a pattern of violation of community standards, including sustained inappropriate behavior, harassment of an individual, or aggression toward or disparagement of classes of individuals. Consequence : A permanent ban from any sort of public interaction within the community.","ref":"code_of_conduct.html#enforcement-guidelines","title":"Code of Conduct - Enforcement Guidelines","type":"extras"},{"doc":"This Code of Conduct is adapted from the Contributor Covenant , version 2.1, available at https://www.contributor-covenant.org/version/2/1/code_of_conduct.html . Community Impact Guidelines were inspired by Mozilla's code of conduct enforcement ladder . For answers to common questions about this code of conduct, see the FAQ at https://www.contributor-covenant.org/faq . Translations are available at https://www.contributor-covenant.org/translations .","ref":"code_of_conduct.html#attribution","title":"Code of Conduct - Attribution","type":"extras"}]